<template>
  <div class="wait-task-stmms">
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="dataList" :height="tableHeight">
        <el-table-column
          type="index"
          label="序号"
          width="70"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column
          prop="courseName"
          label="课程（代码）"
          min-width="300"
          show-overflow-tooltip
        >
          <span slot-scope="scope">
            {{ scope.row.courseName }}（{{ scope.row.courseCode }}）
          </span>
        </el-table-column>
        <el-table-column
          prop="paperNumber"
          label="试卷编号"
          min-width="220"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          prop="paperType"
          label="试卷类型"
          width="90"
        ></el-table-column>
        <el-table-column
          class-name="action-column"
          label="操作"
          width="120"
          fixed="right"
        >
          <template slot-scope="scope">
            <el-button
              class="btn-primary"
              type="text"
              :disabled="scope.row.taskStatus === 'RUNNING'"
              @click="toSetParams(scope.row)"
              >评卷参数设置</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div v-if="!isOnePage" class="part-page">
        <el-pagination
          background
          layout="total, prev, pager, next, jumper"
          :pager-count="5"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
        >
        </el-pagination>
      </div>
    </div>

    <ModifyMarkParams
      ref="ModifyMarkParams"
      :instance="curTask"
      @modified="updateList"
    />
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { stmmsWaitTaskListPage } from "../api";
import ModifyMarkParams from "../../mark/components/markParam/ModifyMarkParams.vue";

export default {
  name: "wait-task-stmms",
  components: {
    ModifyMarkParams,
  },
  data() {
    return {
      current: 1,
      size: 2,
      total: 0,
      dataList: [],
      curTask: {},
      curMarkLeaders: [],
    };
  },
  computed: {
    ...mapState("exam", ["waitTask"]),
    isOnePage() {
      return this.waitTask.stmms <= 3;
    },
    pageSize() {
      return this.isOnePage ? 3 : 2;
    },
    tableHeight() {
      return this.isOnePage ? 174 : 127;
    },
  },
  mounted() {
    this.getList();
  },
  methods: {
    ...mapActions("exam", ["updateWaitTaskCount"]),
    async updateList() {
      await this.updateWaitTaskCount();
      await this.getList();
    },
    async getList() {
      const datas = {
        pageNumber: this.current,
        pageSize: this.pageSize,
      };
      const data = await stmmsWaitTaskListPage(datas);
      this.dataList = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toSetParams(row) {
      this.curTask = row;
      this.$refs.ModifyMarkParams.open();
    },
  },
};
</script>
